<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaymentMethodProfileCounts ArrayType
 * @subpackage Arrays
 */
class ArrayOfPaymentMethodProfileCounts extends AbstractStructArrayBase
{
    /**
     * The PaymentMethodProfileCounts
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\PaymentMethodProfileCounts[]
     */
    public $PaymentMethodProfileCounts;
    /**
     * Constructor method for ArrayOfPaymentMethodProfileCounts
     * @uses ArrayOfPaymentMethodProfileCounts::setPaymentMethodProfileCounts()
     * @param \eBizCharge\StructType\PaymentMethodProfileCounts[] $paymentMethodProfileCounts
     */
    public function __construct(array $paymentMethodProfileCounts = array())
    {
        $this
            ->setPaymentMethodProfileCounts($paymentMethodProfileCounts);
    }
    /**
     * Get PaymentMethodProfileCounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\PaymentMethodProfileCounts[]|null
     */
    public function getPaymentMethodProfileCounts()
    {
        return isset($this->PaymentMethodProfileCounts) ? $this->PaymentMethodProfileCounts : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentMethodProfileCounts method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentMethodProfileCounts method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentMethodProfileCountsForArrayConstraintsFromSetPaymentMethodProfileCounts(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPaymentMethodProfileCountsPaymentMethodProfileCountsItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaymentMethodProfileCountsPaymentMethodProfileCountsItem instanceof \eBizCharge\StructType\PaymentMethodProfileCounts) {
                $invalidValues[] = is_object($arrayOfPaymentMethodProfileCountsPaymentMethodProfileCountsItem) ? get_class($arrayOfPaymentMethodProfileCountsPaymentMethodProfileCountsItem) : sprintf('%s(%s)', gettype($arrayOfPaymentMethodProfileCountsPaymentMethodProfileCountsItem), var_export($arrayOfPaymentMethodProfileCountsPaymentMethodProfileCountsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentMethodProfileCounts property can only contain items of type \eBizCharge\StructType\PaymentMethodProfileCounts, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentMethodProfileCounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\PaymentMethodProfileCounts[] $paymentMethodProfileCounts
     * @return \eBizCharge\ArrayType\ArrayOfPaymentMethodProfileCounts
     */
    public function setPaymentMethodProfileCounts(array $paymentMethodProfileCounts = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentMethodProfileCountsArrayErrorMessage = self::validatePaymentMethodProfileCountsForArrayConstraintsFromSetPaymentMethodProfileCounts($paymentMethodProfileCounts))) {
            throw new \InvalidArgumentException($paymentMethodProfileCountsArrayErrorMessage, __LINE__);
        }
        if (is_null($paymentMethodProfileCounts) || (is_array($paymentMethodProfileCounts) && empty($paymentMethodProfileCounts))) {
            unset($this->PaymentMethodProfileCounts);
        } else {
            $this->PaymentMethodProfileCounts = $paymentMethodProfileCounts;
        }
        return $this;
    }
    /**
     * Add item to PaymentMethodProfileCounts value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\PaymentMethodProfileCounts $item
     * @return \eBizCharge\ArrayType\ArrayOfPaymentMethodProfileCounts
     */
    public function addToPaymentMethodProfileCounts(\eBizCharge\StructType\PaymentMethodProfileCounts $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\PaymentMethodProfileCounts) {
            throw new \InvalidArgumentException(sprintf('The PaymentMethodProfileCounts property can only contain items of type \eBizCharge\StructType\PaymentMethodProfileCounts, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentMethodProfileCounts[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\PaymentMethodProfileCounts|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\PaymentMethodProfileCounts|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\PaymentMethodProfileCounts|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\PaymentMethodProfileCounts|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\PaymentMethodProfileCounts|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentMethodProfileCounts
     */
    public function getAttributeName()
    {
        return 'PaymentMethodProfileCounts';
    }
}
