<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GwRecurringBilling StructType
 * @subpackage Structs
 */
class GwRecurringBilling extends AbstractStructBase
{
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Amount;
    /**
     * The Enabled
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Enabled;
    /**
     * The Expire
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Expire;
    /**
     * The Next
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Next;
    /**
     * The NumLeft
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NumLeft;
    /**
     * The Schedule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Schedule;
    /**
     * Constructor method for GwRecurringBilling
     * @uses GwRecurringBilling::setAmount()
     * @uses GwRecurringBilling::setEnabled()
     * @uses GwRecurringBilling::setExpire()
     * @uses GwRecurringBilling::setNext()
     * @uses GwRecurringBilling::setNumLeft()
     * @uses GwRecurringBilling::setSchedule()
     * @param float $amount
     * @param bool $enabled
     * @param string $expire
     * @param string $next
     * @param string $numLeft
     * @param string $schedule
     */
    public function __construct($amount = null, $enabled = null, $expire = null, $next = null, $numLeft = null, $schedule = null)
    {
        $this
            ->setAmount($amount)
            ->setEnabled($enabled)
            ->setExpire($expire)
            ->setNext($next)
            ->setNumLeft($numLeft)
            ->setSchedule($schedule);
    }
    /**
     * Get Amount value
     * @return float
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \eBizCharge\StructType\GwRecurringBilling
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: float
        if (!is_null($amount) && !(is_float($amount) || is_numeric($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get Enabled value
     * @return bool
     */
    public function getEnabled()
    {
        return $this->Enabled;
    }
    /**
     * Set Enabled value
     * @param bool $enabled
     * @return \eBizCharge\StructType\GwRecurringBilling
     */
    public function setEnabled($enabled = null)
    {
        // validation for constraint: boolean
        if (!is_null($enabled) && !is_bool($enabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($enabled, true), gettype($enabled)), __LINE__);
        }
        $this->Enabled = $enabled;
        return $this;
    }
    /**
     * Get Expire value
     * @return string|null
     */
    public function getExpire()
    {
        return $this->Expire;
    }
    /**
     * Set Expire value
     * @param string $expire
     * @return \eBizCharge\StructType\GwRecurringBilling
     */
    public function setExpire($expire = null)
    {
        // validation for constraint: string
        if (!is_null($expire) && !is_string($expire)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expire, true), gettype($expire)), __LINE__);
        }
        $this->Expire = $expire;
        return $this;
    }
    /**
     * Get Next value
     * @return string|null
     */
    public function getNext()
    {
        return $this->Next;
    }
    /**
     * Set Next value
     * @param string $next
     * @return \eBizCharge\StructType\GwRecurringBilling
     */
    public function setNext($next = null)
    {
        // validation for constraint: string
        if (!is_null($next) && !is_string($next)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($next, true), gettype($next)), __LINE__);
        }
        $this->Next = $next;
        return $this;
    }
    /**
     * Get NumLeft value
     * @return string|null
     */
    public function getNumLeft()
    {
        return $this->NumLeft;
    }
    /**
     * Set NumLeft value
     * @param string $numLeft
     * @return \eBizCharge\StructType\GwRecurringBilling
     */
    public function setNumLeft($numLeft = null)
    {
        // validation for constraint: string
        if (!is_null($numLeft) && !is_string($numLeft)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numLeft, true), gettype($numLeft)), __LINE__);
        }
        $this->NumLeft = $numLeft;
        return $this;
    }
    /**
     * Get Schedule value
     * @return string|null
     */
    public function getSchedule()
    {
        return $this->Schedule;
    }
    /**
     * Set Schedule value
     * @param string $schedule
     * @return \eBizCharge\StructType\GwRecurringBilling
     */
    public function setSchedule($schedule = null)
    {
        // validation for constraint: string
        if (!is_null($schedule) && !is_string($schedule)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($schedule, true), gettype($schedule)), __LINE__);
        }
        $this->Schedule = $schedule;
        return $this;
    }
}
